/** 
	 Clase coneDraw que contiene la estructura de puntos de un cono

	 Silvana Bravo Hernandez
	 Noviembre del 2001

	Modificado por Fraga Nov 19, 2002
**/
 
#include <math.h>
#include "cone.h"

Cone::Cone( float ccx, float ccy, float ccz, 
	float caltura, float cradio)
{

	cx = ccx;
	cy = ccy;
	cz = ccz;
	high = caltura;
	radius = cradio;   
	getcone( );

	R = G = B = 1.0;  // white
}

/** 
	Funcion que genera el cono en el centro(cx,cy,cz),
	altura hight y radio radius
**/
void Cone::getcone ( )
{
	int i;

	// El vrtice 0, v0 = 
	v[0][0] = cx; v[0][1] = cy+high; v[0][2] = cz; 
	normal[0][0] = 0; normal[0][1] = 0; normal[0][2] = 1;

	float incrang = 360.0/NPOINTS;

	float theta = atan ( radius / high );
	float sintheta = sin ( theta );
	float costheta = cos ( theta );

	float alpha = atan ( radius / high );
	float sinalpha = sin ( theta );

	for ( i=1; i<=NPOINTS; i++ ) { 
		float ang = (i-1)*incrang;

		float sintheta = sin ( ang * M_PI/180.0 );
		float costheta = cos ( ang * M_PI/180.0 );

		v[i][0] = cx + costheta * radius; 
		v[i][1] = cy;
		v[i][2] = cz + sintheta * radius; 

		normal[i][0] = costheta;
		normal[i][1] = sinalpha;
		normal[i][2] = sintheta; 
	}
}

void Cone::color(float x,float y,float z)
{
  R = x;
  G = y;
  B = z;
}

void Cone::show (  )
{
	int i;

	for (i = 1; i <= NPOINTS; i++) {
		glBegin(GL_TRIANGLES);

		glColor3f( R, G, B );
		glVertex3fv( &v[i][0]);

		glColor3f( 1.0, 0.0, 1.0 );
		glVertex3fv( &v[0][0]);
		int index = i%NPOINTS + 1;

		glColor3f( R, G, B );
		glVertex3fv( &v[index][0]);

		glEnd();
	}
}

